SHEBANG
# Copyright @BABOLO (C)2002,2003
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.1 2003/05/03 04:27:56 babolo Exp $

JNTROSTUP(qmail,,dnl
,dnl
# jailup ${inclass} dir jailname jailaddr
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# installed ports/mail/qmail or ports/mail/qmail-tls
#           ports/security/checkpassword
#           ports/security/xinetd
#                                                   useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/control" "${conf_dir}/alias"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(host.conf hosts resolv.conf protocols)
${up_conf} "${conf_dir}/" /var/qmail/ << "EOF"
    control/concurrencyremote
    control/defaultdomain
    control/locals
    control/me
    control/rcpthosts
    control/smtproutes
    alias/.qmail-mailer-daemon
    alias/.qmail-postmaster
    alias/.qmail-root
EOF

for i in cert clientcert servercert; do
    if  [ -s /var/qmail/control/${i}.pem ]; then
        echo ${i}.pem | ${up_conf} "${conf_dir}/control/" /var/qmail/control/
    fi
done
if  [ ! -s "${conf_dir}/control/servercert.pem" ]; then
    if  [ -s "${conf_dir}/control/cert.pem" ]; then
        ${cp} -pf "${conf_dir}/control/cert.pem" "${conf_dir}/control/servercert.pem"
    elif [ -s "${conf_dir}/control/clientcert.pem" ]; then
        ${cp} -pf "${conf_dir}/control/clientcert.pem" "${conf_dir}/control/servercert.pem"
fi; fi
if  [ ! -s "${conf_dir}/control/clientcert.pem" ]; then
    if  [ -s "${conf_dir}/control/cert.pem" ]; then
        ${cp} -pf "${conf_dir}/control/cert.pem" "${conf_dir}/control/clientcert.pem"
    elif [ -s "${conf_dir}/control/servercert.pem" ]; then
        ${cp} -pf "${conf_dir}/control/servercert.pem" "${conf_dir}/control/clientcert.pem"
fi; fi

${up_data} "${main_dir}" << "EOF"
    /var/qmail/queue/lock/tcpto
    /var/qmail/queue/lock/sendmutex
EOF

${up_shlib} "${main_dir}/usr/lib" << "EOF"
    c crypt crypto m md ssl wrap
EOF

${up_libexe} "${main_dir}/usr/libexec" << EOF
    ld-elf.so.1
    xinetd
EOF

${up_genlist} var/qmail/bin/ ${MTREE} | ${up_exec} "${main_dir}/var/qmail/bin" "/var/qmail/bin"

if  [ ! -p "${main_dir}/var/qmail/queue/lock/trigger" ]; then
    ${rm} -f "${main_dir}/var/qmail/queue/lock/trigger"
    ${mkfifo} -m 0622 "${main_dir}/var/qmail/queue/lock/trigger"
fi

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
cf=xinetd; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
defaults
{
	log_type	= SYSLOG daemon
	log_on_success	= PID HOST DURATION
	log_on_failure	= HOST RECORD
}

service	smtp
{
	env		= RELAYCLIENT=
	type		= UNLISTED
	protocol	= tcp
	socket_type	= stream
	port		= 25
	wait		= no
	user		= qmaild
	group		= nogroup
	instances	= 100
	server		= /var/qmail/bin/tcp-env
	server_args	= /var/qmail/bin/qmail-smtpd
	only_from	= 127.0.0.1
	only_from	+= 127.0.0.0/24
}
EOF

cf=group; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
wheel:*:0:root
nogroup:*:65533:
nobody:*:65534:
qmail:*:82:
qnofiles:*:81:
EOF

cf=master.passwd; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
root:*:0:0::0:0:Charlie &:/:/nonexistent
nobody:*:65534:65534::0:0:Unprivileged user:/nonexistent:/nonexistent
alias:*:81:81::0:0:Qmailalias:/var/qmail/alias:/nonexistent
qmaill:*:83:81::0:0:Qmail l:/var/qmail:/nonexistent
qmaild:*:82:81::0:0:Qmail d:/var/qmail:/nonexistent
qmailp:*:84:81::0:0:Qmail p:/var/qmail:/nonexistent
qmailq:*:85:82::0:0:Qmail q:/var/qmail:/nonexistent
qmailr:*:86:82::0:0:Qmail r:/var/qmail:/nonexistent
qmails:*:87:82::0:0:Qmail s:/var/qmail:/nonexistent
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${up_mtree} "${main_dir}" ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.				type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    master.passwd		mode=0600
    protocols
    resolv.conf
    xinetd
    control			type=dir mode=0755
        cert.pem		uname=qmaild gname=qmail mode=0440
        servercert.pem		uname=qmaild gname=qmail mode=0440
        clientcert.pem		uname=qmaild gname=qmail mode=0440
        concurrencyremote
        defaultdomain
        locals
        me
        rcpthosts
        smtproutes
    ..
    alias			type=dir mode=0755
/set gname=qmail
        .qmail-mailer-daemon
        .qmail-postmaster
        .qmail-root
    ..
..
EOF

${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

${cat} << EOF >> "${genconfig}"
#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	0	0
#${genclass}	xinetd		${jdir}	${jailsname}	${jailsaddr}	0	0	0	xinetd
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
#/null			${main_dir}/dev	null	ro,noexec	0 0
#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
